﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
# author: observer
# email: jingchaohu@gmail.com
# blog: http://obmem.com

import random
import os,sys
import web
import sqlite3
import time
import re

#web.config.debug = False

curpath = os.path.dirname(os.path.realpath(sys.argv[0]))

db = web.database(dbn='sqlite', db='verycd.sqlite3.db')
dbc = web.database(dbn='sqlite', db='comment.sqlite3.db')
dbs = web.database(dbn='sqlite',db='stat.sqlite3.db')
dbl = web.database(dbn='sqlite',db='lock.sqlite3.db')


urls = (
	'/', 'index',
	'/id/(.+)','id',
	'/comment/(.*)','comment',
	'/user/(.*)','user',
)

def getsubs(edstr):
	subs = re.compile(r'(ed2k://.*?\|/)').findall(edstr)
	if subs:
		subs = [ [x,x.split('|')[2]] for x in subs ]
		return subs
	else:
		return []

def unquote2(s):
	s = s.encode('utf-8')
	r = ''
	i = 0
	while i < len(s):
		if s[i] != '%':
			r += s[i]
			i += 1
		else:
			r += chr(int(s[i+1:i+3],16))
			i += 3
	return r.decode('utf-8')

def notfound():
	return web.notfound(open('static/404.html').read())

def internalerror():
	return web.internalerror(open('static/500.html').read())


render = web.template.render('templates', globals={'getsubs':getsubs})


app = web.application(urls, globals())

app.notfound = notfound
#app.internalerror = internalerror

class user:
	def GET(self,user):
		# type=1,fav; type=2,recent, type=3,cmt
		type = 0
		if '.' not in user:
			arg = 1
		else:
			spuser = user.split('.')
			arg = int(spuser[-1])
			user = spuser[0]
			if len(spuser)==3:
				type = int(spuser[1])

		page = int(arg)
		recs = dbl.select('lock',where='owner="'+user+'"',order='updtime desc',limit=10,offset=(page-1)*10)
		num = dbl.select('lock',where='owner="'+user+'"',what='count(*) as count')[0].count
		pages = [ page-1, page+1, (num-1)/10+1 ]

		pop = dbl.select('lock',where='owner="'+user+'"',order='vcpv desc',limit=10,offset=(page-1)*10)

		try:
			posts = dbc.select('comment',where='username="'+user+'"',order='time desc',limit=10,offset=(page-1)*10)
			nposts = dbc.select('comment',where='username="'+user+'"',what='count(*) as count')[0].count
			npages = [ page-1, page+1, (nposts-1)/10+1 ]
			posts = [ x for x in posts ]
			ids = [ str(x.id) for x in posts ]
			ttls = db.select('verycd',what='verycdid,title',where='verycdid in ('+','.join(ids)+')')
			ttls = [ x for x in ttls ]
		except:
			posts = []
			ttls = []
		rtn = []
		for y in posts:
			for x in ttls:
				if y.id == x.verycdid:
					rtn.append([y.id,x.title,time.strftime('%Y/%m/%d %H:%M:%S',time.gmtime(int(y.time)+3600*11))])
					break
		return render.user([recs,user,pages,pop,rtn,type,npages])

# top user
class top4:
	def GET(self):
#	select owner,sum(vcpv) as sum from lock group by owner order by sum desc limit 20;	
		pop = dbl.select('lock',what='owner,sum(vcpv) as sum,count(*) as count,id,title',group='owner',order='sum desc',limit=20)
		pop = [ x for x in pop ] 
		return render.top4(pop)

class top3:
	def GET(self):
		i = web.input(cat=None,status=None)
		if i.cat:
			where = 'category1 = "'+i.cat+'"'
		else:
			where = 'id != 1'
		if i.status:
			if i.status == '0':
				i.status = '审核中资源 '
			elif i.status == '3':
				i.status = '自定义 '
			where += ' and status = "'+i.status+'"'
		rec = dbs.select('t1',order='vcpv desc',limit=400,where=where)
		rec = [ x for x in rec ]
		return render.top3(rec)

class top2:
	def GET(self):
		i = web.input(cat=None,status=None)
		if i.cat:
			where = 'category1 = "'+i.cat+'"'
		else:
			where = 'id != 1'
		if i.status:
			if i.status == '0':
				i.status = '审核中资源 '
			elif i.status == '3':
				i.status = '自定义 '
			where += ' and status = "'+i.status+'"'
		rec = dbs.select('t1',order='score desc',limit=20,where=where)
		rec = [ x for x in rec ]
		return render.top2(rec)

class top:
	def GET(self,num):
		if num:
			if not num.isdigit():
				num = 20
			elif int(num)>100:
				num = 100
		else:
			num = 20
		i = web.input(cat=None)
		rec2 = dbs.select('stat',order='score desc',limit='%s'%str(num))
		rec2 = [ x for x in rec2 ]
		where = 'verycdid in (' + ','.join([ str(x.id) for x in rec2 ]) + ')'
		rec1 = db.select('verycd',where=where)
		rec1 = [ x for x in rec1 ]
		return render.top([rec1,rec2,i.cat])

class rand:
	def GET(self):
		count = db.select('verycd',what='count (*) as count',order='updtime')[0].count
		offset = random.randint(0,count-1)
		id = db.select('verycd',what='verycdid',order='updtime',limit=1,offset=offset)[0].verycdid
		myvar = dict(id=id)
		recl = dbl.select('lock',vars=myvar,where='id=$id')
		recl = [ x for x in recl ]
		rec = db.select('verycd',vars=myvar,where="verycdid=$id")
		for r in rec:
			r2 = [r.verycdid,r.title,r.status,r.brief,r.pubtime,r.updtime,r.category1,r.category2,r.ed2k,r.content,r.related]
			fl = None
			return render.id([r2,fl,str(r['verycdid']),recl])
		return render.e404([])


class comment:
	def GET(self,id):
		if '.' in id:
			page = long(id.split('.')[1])
			id = long(id.split('.')[0])
		else:
			id = long(id)
			page = 1
		cts = dbc.select('comment',where='id=%d'%id,order='time DESC')
		cts = [ x for x in cts ]
		for i in range(len(cts)):
			cts[i].time = time.strftime('%Y/%m/%d %H:%M:%S',time.gmtime(cts[i].time+3600*11))
		return render.comment([cts,id,page])

class otz:
	def GET(self):
		return render.otz('')

class search:
	def GET(self):
		i = web.input(title=None,cat1=None,cat2=None,release=None,lang=None,loc=None,pubtime=None,page=1,\
			imdb1=None,imdb2=None,genre=None,platform=None,gametype=None,producer=None,press=None,\
			booktype=None)
		eachpage = 10
		offset = eachpage*(int(i.page)-1)
		where = []
		arg = '/search/?td=as'
		if i.cat1:
			where.append('category1 = "'+i.cat1+'"')
			arg += '&cat1='+i.cat1
		if i.cat2:
			where.append('category2 = "'+i.cat2+'"')
			arg += '&cat2='+i.cat2
		if i.pubtime:
			where.append('pubtime like "'+i.pubtime+'%"')
			arg += '&pubtime='+i.pubtime
		if i.imdb1:
			where.append('brief like "IMDb%" and brief > "IMDb:&nbsp;'+i.imdb1+'"')
			arg += '&imdb1='+i.imdb1
			if not i.imdb2:
				i.imdb2 = '9.9'
		if i.imdb2:
			where.append('brief like "IMDb%" and brief < "IMDb:&nbsp;'+i.imdb2+'"')
			arg += '&imdb2='+i.imdb2
		if i.platform:
			where.append(u'brief like "游戏平台:&nbsp;'+i.platform+'%"')
			arg += '&platform='+i.platform
		if i.booktype:
			where.append(u'brief like "图书分类:&nbsp;'+i.booktype+'%"')
			arg += '&booktype='+i.booktype
		if i.genre:
			where.append(u'brief like "%'+i.genre+'%"')
			arg += '&genre='+i.genre
		if i.title:
			where.append('title like "%'+i.title+'%"')
			arg += '&title='+i.title
		if i.release:
			where.append(u'brief like "%:&nbsp;'+i.release+u'年%"')
			arg += '&release='+i.release
		if i.lang:
			where.append(u'brief like "%语言:&nbsp;%'+i.lang+'%"')
			arg += '&lang='+i.lang
		if i.loc:
			where.append(u'brief like "%地区:&nbsp;'+i.loc+'%"')
			arg += '&loc='+i.loc
		if i.gametype:
			where.append(u'brief like "%游戏类型:&nbsp;'+i.gametype+'%"')
			arg += '&gametype='+i.gametype
		if i.producer:
			where.append(u'brief like "%制作发行:&nbsp;%'+i.producer+'%"')
			arg += '&producer='+i.producer
		if i.press:
			where.append(u'brief like "%出版社:&nbsp;%'+i.press+'%"')
			arg += '&press='+i.press
		arg += '&page'
		where = ' and '.join(where)
		if where == '':
			where = 'updtime != "1"'
		num = db.select('verycd',what='count(*) as count', where=where)[0].count
		vc = db.select('verycd',order='updtime DESC',limit=eachpage,\
					offset=offset,where=where)
		prev = int(i.page)-1 == 0 and '1' or str(int(i.page)-1)
		next = int(i.page)+1 <= (num-1)/eachpage+1 and str(int(i.page)+1) or i.page
		end = str((num-1)/eachpage+1)
		pages = [prev,next,end]
		left = min(4,int(i.page)-1)
		right = min(4,int(end)-int(i.page))
		if left < 4:
			right = min(8-left,int(end)-int(i.page))
		if right < 4:
			left = min(8-right,int(i.page)-1)
		while left > 0:
			pages.append(str(int(i.page)-left))
			left -= 1
		j = 0
		while j <= right:
			pages.append(str(int(i.page)+j))
			j += 1
		return render.search([vc,pages,arg,i])

class id:
	def GET(self,id):
		if not id.isdigit():
			raise seeother('/id/1000')
		myvar = dict(id=id)
		recl = dbl.select('lock',vars=myvar,where='id=$id')
		recl = [ x for x in recl ]
		try:
			rec = db.select('verycd',vars=myvar,where="verycdid=$id")
		except:
			rec = db.select('verycd',what='verycdid,title,status,brief,pubtime,updtime,category1,category2,ed2k,content',vars=myvar,where="verycdid=$id")
		for r in rec:
			fl = None
			try:
				r2 = [r.verycdid,r.title,r.status,r.brief,r.pubtime,r.updtime,r.category1,r.category2,r.ed2k,r.content,r.related]
			except:
				r2 = [r.verycdid,r.title,r.status,r.brief,r.pubtime,r.updtime,r.category1,r.category2,r.ed2k,r.content,'']
			idhtml = render.id([r2,fl,str(r['verycdid']),recl])
			return idhtml
		return render.e404([])

class index:
	def GET(self):
		i = web.input(id=None,page='1',q=None,download=None,qa=None,cat=None,status=None)
		hot=''
		#显示单个资源
		if i.id:
			raise web.seeother('/idr/'+str(i.id))
		#显示最新更新的资源
		else:
			#深度搜索
			if i.qa:
				qa = '+'.join(i.qa.split(' '))
				open('searchqueue','a').write(qa.encode('utf-8')+'\n')
				return render.fin(qa)
			#显示审核中资源
			elif i.status:
				if i.status=='0':
					where = 'status = "审核中资源 "'
				elif i.status=='1':
					where = 'status = "普通资源 "'
				elif i.status=='2':
					where = 'status = "精华资源 "'
				else:
					where = 'status = "自定义 "'
				vc = db.select('verycd',what='verycdid,title,brief,updtime',where=where,order='updtime DESC',limit=20,offset=20*(int(i.page)-1))
				num = db.select('verycd',what='count(*) as count',where=where)[0].count
				arg = '/?'
#				if i.q:
#					arg += 'q='+i.q+'&'
				arg += 'status='+i.status+'&page'
			#默认情况，不指定分类，没有搜索关键字
			elif (not i.q) and (not i.cat):
				vc = db.select('verycd',what='verycdid,title,updtime',where='updtime>"1971"',order='updtime DESC',limit=20,offset=20*(int(i.page)-1))
				num = db.select('verycd',where='updtime>"1971"',what="count(*) as count")[0].count
				arg = '/?page'
			#无搜索关键字，指定分类
			elif (not i.q) and (i.cat):
				myvar = dict(cat=i.cat)
				vc = db.select('verycd',what='verycdid,title,brief,updtime',order='updtime DESC',vars=myvar,where='category1=$cat',limit=20,offset=20*(int(i.page)-1))
				num = db.select('verycd',what="count(*) as count",vars=myvar,where='category1=$cat')[0].count
				arg = '/?cat='+i.cat+'&page'
			#有搜索关键字，指定分类
			elif (i.q) and (i.cat):
#				qs = i.q.split(' ')
				qs = re.split(r'\.| ',i.q)
				qs = [ 'title like \'%'+x+'%\'' for x in qs ]
				where = ' and '.join(qs)
				where += ' and category1=\''+i.cat+'\''
				vc = db.select('verycd',what='verycdid,title,brief,updtime',order='updtime DESC',limit=20,\
					offset=20*(int(i.page)-1),where=where)
				num = db.select('verycd',what="count(*) as count",where=where)[0].count
				arg = '/?q='+i.q+'&cat='+i.cat+'&page'
			#有搜索关键字，不指定分类
			else:
#				qs = i.q.split(' ')
				qs = re.split(r'\.| ',i.q)
				qs = [ 'title like \'%'+x+'%\'' for x in qs ]
				where = ' and '.join(qs)
				vc = db.select('verycd',what='verycdid,title,brief,updtime',order='updtime DESC',limit=10,\
					offset=10*(int(i.page)-1),where=where)
				#num = db.select('verycd',what="count(*) as count",where=where)[0].count
				#if vc.__len__ <20:
				#	num = 20*(int(i.page)-1)+vc.__len__
				#else:
#				num = db.select('verycd',order='updtime DESC',what='count(updtime) as count',where=where)[0].count
				num = 200
				arg = '/?q='+i.q+'&page'
			prev = int(i.page)-1 == 0 and '1' or str(int(i.page)-1)
			next = int(i.page)+1 <= (num-1)/20+1 and str(int(i.page)+1) or i.page
			end = str((num-1)/20+1)
			pages = [prev,next,end]
			left = min(4,int(i.page)-1)
			right = min(4,int(end)-int(i.page))
			if left < 4:
				right = min(8-left,int(end)-int(i.page))
			if right < 4:
				left = min(8-right,int(i.page)-1)
			while left > 0:
				pages.append(str(int(i.page)-left))
				left -= 1
			j = 0
			while j <= right:
				pages.append(str(int(i.page)+j))
				j += 1
		#	vc = [ x for x in vc ]
			vc2 = []
			try:
				for x in vc:
					try:
						vc2.append( x )
					except:
						continue
			except:
				pass
			vc = vc2				
				

			#owners
			owners = []
			for x in vc:
				try:
					owners.append( dbl.select('lock',where='id='+str(x.verycdid))[0].owner )
				except:
					owners.append( '' )

			top = False

			return render.index([vc,pages,arg,i.q,num,i.cat,hot,i.status,top,owners])
if __name__ == "__main__":
	app.run()
